/*
 * Black_sf.c
 *
 * Real-Time Workshop code generation for Simulink model "Black_sf.mdl".
 *
 * Model Version              : 1.1
 * Real-Time Workshop version : 6.6  (R2007a)  01-Feb-2007
 * C source code generated on : Thu Jun 19 15:17:29 2008
 */

#include <math.h>
#include "Black_sf.h"
#include "Black_sf_private.h"
#include "simstruc.h"
#include "fixedpoint.h"
#if defined(RT_MALLOC) || defined(MATLAB_MEX_FILE)

extern void *Black_malloc(SimStruct *S);

#endif

#ifndef __RTW_UTFREE__
#if defined (MATLAB_MEX_FILE)

extern void * utMalloc(size_t);
extern void utFree(void *);

#endif
#endif                                 /* #ifndef __RTW_UTFREE__ */

#if defined(MATLAB_MEX_FILE)
#include "rt_nonfinite.c"
#endif

/* Initial conditions for root system: '<Root>' */
#define MDL_INITIALIZE_CONDITIONS

static void mdlInitializeConditions(SimStruct *S)
{
  /* TransferFcn Block: '<S1>/Black Box' */
  ((ContinuousStates_Black *) ssGetContStates(S))->BlackBox_CSTATE[0] = 0.0;
  ((ContinuousStates_Black *) ssGetContStates(S))->BlackBox_CSTATE[1] = 0.0;
}

/* Start for root system: '<Root>' */
#define MDL_START

static void mdlStart(SimStruct *S)
{
  /* instance underlying S-Function data */
#if defined(RT_MALLOC) || defined(MATLAB_MEX_FILE)
#  if defined(MATLAB_MEX_FILE)

  /* non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* Check for invalid switching between solver types */
  if (ssIsVariableStepSolver(S)) {
    ssSetErrorStatus(S, "This Real-Time Workshop generated "
                     "S-function cannot be used in a simulation with "
                     "a solver type of variable-step "
                     "because this S-function was created from a model with "
                     "solver type of fixed-step and it has continuous time blocks. "
                     "See the Solver page of the simulation parameters dialog.");
    return;
  }

  if (fabs(ssGetFixedStepSize(S) - 0.001) > mxGetEps()*100*0.001) {
    ssSetErrorStatus(S, "This Real-Time Workshop generated "
                     "S-function cannot be used in a simulation with "
                     "the current fixed step size "
                     "because this S-function was created from a model with "
                     "a fixed step size of 0.001 and had both "
                     "continuous blocks and discrete blocks running at this rate. "
                     "See the Solver page of the simulation parameters dialog.");
    return;
  }

#  endif

  Black_malloc(S);
  if (ssGetErrorStatus(S) != NULL ) {
    return;
  }

#endif

  {
  }
}

/* Outputs for root system: '<Root>' */
static void mdlOutputs(SimStruct *S, int_T tid)
{
  if (ssIsContinuousTask(S, tid)) {    /* Sample time: [0.0s, 0.0s] */
    /* TransferFcn Block: '<S1>/Black Box' */
    ((BlockIO_Black *) ssGetLocalBlockIO(S))->BlackBox = 0.0*
      ((ContinuousStates_Black *) ssGetContStates(S))->BlackBox_CSTATE[0]
      + 1000.0*((ContinuousStates_Black *) ssGetContStates(S))->BlackBox_CSTATE
      [1];

    /* Outport Block: '<Root>/Out'
     */
    ((real_T *)ssGetOutputPortSignal(S, 0))[0] = ((BlockIO_Black *)
      ssGetLocalBlockIO(S))->BlackBox;
  }
}

/* Update for root system: '<Root>' */
#define MDL_UPDATE

static void mdlUpdate(SimStruct *S, int_T tid)
{
  /* tid is required for a uniform function interface. This system
   * is single rate, and in this case, tid is not accessed. */
  UNUSED_PARAMETER(tid);
}

/* Derivatives for root system: '<Root>' */
#define MDL_DERIVATIVES

static void mdlDerivatives(SimStruct *S)
{
  /* TransferFcn Block: '<S1>/Black Box' */
  {
    ((StateDerivatives_Black *) ssGetdX(S))->BlackBox_CSTATE[0] = (*(((const
      real_T**)ssGetInputPortSignalPtrs(S, 0))[0]));
    ((StateDerivatives_Black *) ssGetdX(S))->BlackBox_CSTATE[0] += (-5.0)*
      ((ContinuousStates_Black *) ssGetContStates(S))->BlackBox_CSTATE[0]
      + (-100.0)*((ContinuousStates_Black *) ssGetContStates(S))
      ->BlackBox_CSTATE[1];
    ((StateDerivatives_Black *) ssGetdX(S))->BlackBox_CSTATE[1]=
      ((ContinuousStates_Black *) ssGetContStates(S))->BlackBox_CSTATE[0];
  }
}

/* Terminate for root system: '<Root>' */
static void mdlTerminate(SimStruct *S)
{

#if defined(RT_MALLOC) || defined(MATLAB_MEX_FILE)

  if (ssGetUserData(S) != NULL ) {
    rt_FREE(ssGetLocalBlockIO(S));
  }

  rt_FREE(ssGetUserData(S));

#endif

}

#if defined(RT_MALLOC) || defined(MATLAB_MEX_FILE)
#  include "Black_mid.h"
#endif

/* Function to initialize sizes */
static void mdlInitializeSizes(SimStruct *S)
{
  ssSetNumSampleTimes(S, 2);           /* Number of sample times */
  ssSetNumContStates(S, 2);            /* Number of continuous states */
  ssSetNumNonsampledZCs(S, 0);         /* Number of nonsampled ZCs */

  /* Number of output ports */
  if (!ssSetNumOutputPorts(S, 1))
    return;

  /* outport number: 0 */
  if (!ssSetOutputPortVectorDimension(S, 0, 1))
    return;
  ssSetOutputPortBusMode(S, 0, SL_NON_BUS_MODE);
  if (ssGetSimMode(S) != SS_SIMMODE_SIZES_CALL_ONLY) {
    ssSetOutputPortDataType(S, 0, SS_DOUBLE);
  }

  ssSetOutputPortSampleTime(S, 0, 0.0);
  ssSetOutputPortOffsetTime(S, 0, 0.0);
  ssSetOutputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);

  /* Number of input ports */
  if (!ssSetNumInputPorts(S, 1))
    return;

  /* inport number: 0 */
  {
    if (!ssSetInputPortVectorDimension(S, 0, 1))
      return;
    ssSetInputPortBusMode(S, 0, SL_NON_BUS_MODE);
    if (ssGetSimMode(S) != SS_SIMMODE_SIZES_CALL_ONLY) {
      ssSetInputPortDataType(S, 0, SS_DOUBLE);
    }

    ssSetInputPortSampleTime(S, 0, 0.001);
    ssSetInputPortOffsetTime(S, 0, 0.0);
    ssSetInputPortOverWritable(S, 0, 0);
    ssSetInputPortOptimOpts(S, 0, SS_NOT_REUSABLE_AND_GLOBAL);
  }

  ssSetRTWGeneratedSFcn(S, 1);         /* RTW generated S-function */

  /* Tunable Parameters */
  ssSetNumSFcnParams(S, 0);

  /* Number of expected parameters */
#if defined(MATLAB_MEX_FILE)

  if (ssGetNumSFcnParams(S) == ssGetSFcnParamsCount(S)) {

#if defined(MDL_CHECK_PARAMETERS)

    mdlCheckParameters(S);

#endif                                 /* MDL_CHECK_PARAMETERS */

    if (ssGetErrorStatus(S) != NULL ) {
      return;
    }
  } else {
    return;                            /* Parameter mismatch will be reported by Simulink */
  }

#endif                                 /* MATLAB_MEX_FILE */

  /* Options */
  ssSetOptions(S, (SS_OPTION_RUNTIME_EXCEPTION_FREE_CODE |
                   SS_OPTION_PORT_SAMPLE_TIMES_ASSIGNED ));
}

/* Function to initialize sample times */
static void mdlInitializeSampleTimes(SimStruct *S)
{
  /* task periods */
  ssSetSampleTime(S, 0, 0.0);
  ssSetSampleTime(S, 1, 0.001);

  /* task offsets */
  ssSetOffsetTime(S, 0, 0.0);
  ssSetOffsetTime(S, 1, 0.0);
}

#if defined(MATLAB_MEX_FILE)
# include "fixedpoint.c"
# include "simulink.c"
#else
# undef S_FUNCTION_NAME
# define S_FUNCTION_NAME               Black_sf
# include "cg_sfun.h"
#endif                                 /* defined(MATLAB_MEX_FILE) */
